Dynamic chart in JavaScript Chart control

By using html button, you can add the chart dynamically when click the button.

To add the chart dynamically through button click, follow the given steps:

Step 1:

Initially create the html button.

Then create chart inside of button onClick function. Now click the button charts will render based on click count.

The following code sample demonstrates the output.

let count = 0;
document.getElementById('btn').onclick = () => {

    //Create div element dynamically and append to DOM
    var chartEle = document.createElement('div');
    chartEle.id = 'chartContainer' + count;
    document.getElementsByTagName('body')[0].appendChild(chartEle);

    //Created chart here
    var chart = new ej.charts.Chart({
        series: [{
            type: 'Line', xName: 'x', width: 2, marker: { visible: true },
            yName: 'y', name: 'Germany',
            dataSource: [{ x: 1, y: 21 }, { x: 2, y: 24 }, { x: 3, y: 36 },
            { x: 4, y: 38 }, { x: 5, y: 54 }, { x: 6, y: 57 }, { x: 7, y: 70 }],
        }],
        title: 'Inflation - Consumer Price', tooltip: { enable: true }, height: '400', width: '800'
    });
    chart.appendTo('#' + chartEle.id);
    count++;
}
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
      
    <div id="container">
        <div id="element"></div>
    </div>
    <button id="btn">Add Chart</button>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Dynamic chart in Angular Chart component

By using an HTML button, you can add the chart dynamically when the button is clicked.

To add the chart dynamically through a button click, follow the given steps:

Step 1:

Initially, create an HTML button.

Step 2:

Create a chart inside the button’s onClick function. Now, clicking the button will render charts based on the click count.

The following code sample demonstrates the output.

import { ChartModule, ChartAllModule, AccumulationChartAllModule } from '@syncfusion/ej2-angular-charts'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'
import {
    LineSeriesService, DateTimeService, DataLabelService, StackingColumnSeriesService, CategoryService,
    StepAreaSeriesService, SplineSeriesService, ScrollBarService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
    SelectionService, ScatterSeriesService, ZoomService, ColumnSeriesService, AreaSeriesService, RangeAreaSeriesService
} from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule, ChartAllModule, AccumulationChartAllModule, AccumulationChartModule
    ],

providers: [LineSeriesService, DateTimeService, ColumnSeriesService, DataLabelService, ZoomService, StackingColumnSeriesService, CategoryService,
        StepAreaSeriesService, SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
        PieSeriesService, AccumulationTooltipService, ScrollBarService, AccumulationDataLabelService, SelectionService, ScatterSeriesService,
        AreaSeriesService, RangeAreaSeriesService ],
standalone: true,
  selector: 'app-container',
  template: ` <div><button ej-button id='print' (click)='Add()'>Add Chart</button><div  *ngFor="let item of items"><ejs-chart [id]="id" [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Line' xName='x' yName='y' name='Germany' [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart></div></div>`,
})

export class AppComponent implements OnInit {
  public i:number = 0;
  public id:string ='chart-container';
  public chartData?: Object[];
  public marker?: Object;
  public title?: string;
  public items:any =[];
  ngOnInit(): void {
    this.chartData = [{ x: 1, y: 21 }, { x: 2, y: 24 }, { x: 3, y: 36 },
    { x: 4, y: 38 }, { x: 5, y: 54 }, { x: 6, y: 57 }, { x: 7, y: 70 }],
      this.title = 'Inflation - Consumer Price';
    this.marker = { visible: true };
  }
  Add() {
   this.id = 'chart-container' + this.i;
    var item = {
      "id":this.id,
      }
    this.items.push(item);
     this.i++;
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Dynamic chart in Vue Chart component

A chart can be rendered dynamically by using an HTML button. This approach is useful in scenarios where charts need to be created or updated based on user interaction, such as loading data on demand or rendering multiple charts conditionally.

To add a chart dynamically through a button click, follow the steps below.

Step 1:

Create an HTML button initially.

Define the chart creation logic inside the button’s onClick event handler. Each time the button is clicked, the chart is rendered dynamically based on the click count or the associated logic defined in the handler.

The following example demonstrates dynamically rendering a chart when the button is clicked.

<template>
  <div id="app">
    <ejs-button @click="addChart">Add Chart</ejs-button>
  </div>
</template>

<script setup>
import { provide } from "vue";
import { ButtonComponent as EjsButton } from '@syncfusion/ej2-vue-buttons';
import { Chart } from "@syncfusion/ej2-charts";
import { LineSeries } from "@syncfusion/ej2-vue-charts";
Chart.Inject(LineSeries);

var count = 1;

provide('chart', [LineSeries]);

const addChart = () => {
  var chartEle = document.createElement('div');
  chartEle.id = 'container' + count;
  document.getElementsByTagName('body')[0].appendChild(chartEle);

  let chart = new Chart({
    series: [{
      type: 'Line', xName: 'x', width: 2, marker: { visible: true },
      yName: 'y', name: 'Germany',
      dataSource: [{ x: 1, y: 21 }, { x: 2, y: 24 }, { x: 3, y: 36 },
      { x: 4, y: 38 }, { x: 5, y: 54 }, { x: 6, y: 57 }, { x: 7, y: 70 }],
    }],
    title: 'Inflation - Consumer Price', tooltip: { enable: true }, height: '400', width: '800'
  });
  chart.appendTo('#' + chartEle.id);
  count++;
};

</script>

<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
</style>
<template>
  <div id="app">
    <ejs-button @click="addChart">Add Chart</ejs-button>
  </div>
</template>
<script>
import { ButtonComponent } from '@syncfusion/ej2-vue-buttons';
import { Chart } from "@syncfusion/ej2-charts";
import { LineSeries} from "@syncfusion/ej2-vue-charts";
Chart.Inject(LineSeries);

var count = 1;
export default {
name: "App",
components: {
"ejs-button":ButtonComponent
},
  data () {
  },
  provide: {
    chart: [LineSeries]
  },
  methods: {
    addChart: function() {
      var chartEle = document.createElement('div');
      chartEle.id = 'container' + count;
      document.getElementsByTagName('body')[0].appendChild(chartEle);

      let chart = new Chart({
          series: [{
              type: 'Line', xName: 'x', width: 2, marker: { visible: true },
              yName: 'y', name: 'Germany',
              dataSource: [{ x: 1, y: 21 },{ x: 2, y: 24 },{ x: 3, y: 36 },
                      { x: 4, y: 38 },{ x: 5, y: 54 },{ x: 6, y: 57 },{ x: 7, y: 70 }],
              }],
          title: 'Inflation - Consumer Price', tooltip: { enable: true }, height:'400', width: '800'
      });
      chart.appendTo('#' + chartEle.id);
      count++;
    }
  }
}
</script>
<style>
  @import '../node_modules/@syncfusion/ej2-base/styles/material.css';
  @import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
</style>